Bug 1585365 - Review Request: miniupnpd - Daemon to offer UPnP-IGD and NAT-PMP support
Summary: Review Request: miniupnpd - Daemon to offer UPnP-IGD and NAT-PMP support
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-06-02 02:13 UTC by Michael Cronenworth
Modified: 2018-06-15 15:49 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-06-15 15:49:02 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Michael Cronenworth 2018-06-02 02:13:11 UTC
Spec URL: http://michael.cronenworth.com/RPMS/miniupnpd.spec
SRPM URL: http://michael.cronenworth.com/RPMS/miniupnpd-2.1-1.fc28.src.rpm
Description: Daemon to offer UPnP-IGD and NAT-PMP support
Fedora Account System Username: mooninite

Comment 1 Robert-André Mauchin 🐧 2018-06-03 15:33:34 UTC
 - Don't ship the INSTALL file:

miniupnpd.x86_64: W: install-file-in-docs /usr/share/doc/miniupnpd/INSTALL

 - Perm should be 644:

miniupnpd.src: W: strange-permission miniupnpd.service 640

 - You need to include SystemD Requires:

%{?systemd_requires}
BuildRequires: systemd


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Unknown or generated". 137 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/miniupnpd/review-miniupnpd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd/system,
     /usr/lib/systemd
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: miniupnpd-2.1-1.fc29.x86_64.rpm
          miniupnpd-debuginfo-2.1-1.fc29.x86_64.rpm
          miniupnpd-debugsource-2.1-1.fc29.x86_64.rpm
          miniupnpd-2.1-1.fc29.src.rpm
miniupnpd.x86_64: W: spelling-error %description -l en_US UPnP -> Upon
miniupnpd.x86_64: W: install-file-in-docs /usr/share/doc/miniupnpd/INSTALL
miniupnpd.src: W: spelling-error %description -l en_US UPnP -> Upon
miniupnpd.src: W: strange-permission miniupnpd.service 640
4 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 2 Eamon Walsh 2018-06-03 23:59:26 UTC
In the service unit file:
ip6tables_init.sh and ip6tables_removeall.sh are not executed,
add ExecStartPre and ExecStopPost lines for them.

In the service unit file:
-After=network.target network-online.target
+After=network-online.target

In the service unit file, suggest:
-PIDFile=/run/miniupnpd.pid
+PIDFile=/var/run/miniupnpd.pid
since that's where the daemon thinks it is.
Alternately, suggest passing "-P /run/miniupnpd.pid" to the daemon.

In the service unit file, suggest:
+Documentation: http://miniupnp.free.fr/

In the preamble:
https://fedoraproject.org/wiki/Packaging:Scriptlets#Systemd
wants %{?systemd_requires} when the systemd scriptlets are used.

In %build:
-make %{?_smp_mflags} -f Makefile.linux config.h
 #Enable IPv6/IGDv2 support
-sed -i 's/\/*#define ENABLE_IPV6*\//#define ENABLE_IPV6/' config.h
-sed -i 's/\/*#define IGD_V2*\//#define IGD_V2/' config.h
+export CONFIG_OPTIONS="--ipv6 --igd2"
(see Makefile.linux line 8)
Also, the sed lines don't work as intended, the asterisks are not escaped

In %build, suggest:
-export CFLAGS="$RPM_OPT_FLAGS"
+export CFLAGS="%{optflags}"
based on https://pagure.io/package-cleanup-service "Style Guildelines" (6th bullet)

In %install, suggest:
-export STRIP="true"
+export STRIP=/bin/true

In %install, suggest:
-mkdir -p %{buildroot}%{_unitdir}
-cp -p %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
-chmod 644 %{buildroot}%{_unitdir}/%{name}.service
+install -Dpm 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service

The INSTALL file does contain configuration instructions and probably should remain as a documentation file.

Comment 3 Michael Cronenworth 2018-06-04 16:07:39 UTC
(In reply to Robert-André Mauchin from comment #1)
>  - Don't ship the INSTALL file:
> 
> miniupnpd.x86_64: W: install-file-in-docs /usr/share/doc/miniupnpd/INSTALL

It contains notes about the conf file. Nothing in the guidelines denies providing it. Numerous other packages in Fedora provide it. "less" "openssl" "glibc"... all provide it.

>  - Perm should be 644:
> 
> miniupnpd.src: W: strange-permission miniupnpd.service 640

My local copy of the file was set this way. The installed file was correct, but I've fixed this anyway.

>  - You need to include SystemD Requires:
> 
> %{?systemd_requires}
> BuildRequires: systemd

Yep. Missed it. Thanks.

(In reply to Eamon Walsh from comment #2)
> In the service unit file:
> ip6tables_init.sh and ip6tables_removeall.sh are not executed,
> add ExecStartPre and ExecStopPost lines for them.

Sure.

> In the service unit file:
> -After=network.target network-online.target
> +After=network-online.target

Not really any negatives from providing both. I'm happier by leaving both.

> In the service unit file, suggest:
> -PIDFile=/run/miniupnpd.pid
> +PIDFile=/var/run/miniupnpd.pid
> since that's where the daemon thinks it is.
> Alternately, suggest passing "-P /run/miniupnpd.pid" to the daemon.

The /run and /var/run paths are the same. The symlink to /var/run is /run.

> In the service unit file, suggest:
> +Documentation: http://miniupnp.free.fr/

Why? The man page is better.

> In %build:
> -make %{?_smp_mflags} -f Makefile.linux config.h
>  #Enable IPv6/IGDv2 support
> -sed -i 's/\/*#define ENABLE_IPV6*\//#define ENABLE_IPV6/' config.h
> -sed -i 's/\/*#define IGD_V2*\//#define IGD_V2/' config.h
> +export CONFIG_OPTIONS="--ipv6 --igd2"
> (see Makefile.linux line 8)
> Also, the sed lines don't work as intended, the asterisks are not escaped

Thanks.

> In %build, suggest:
> -export CFLAGS="$RPM_OPT_FLAGS"
> +export CFLAGS="%{optflags}"
> based on https://pagure.io/package-cleanup-service "Style Guildelines" (6th
> bullet)

Personal preference... but I've changed it.

> In %install, suggest:
> -export STRIP="true"
> +export STRIP=/bin/true

Not necessary. Path is expected to be present otherwise your "install" or other commands would fail.

> In %install, suggest:
> -mkdir -p %{buildroot}%{_unitdir}
> -cp -p %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
> -chmod 644 %{buildroot}%{_unitdir}/%{name}.service
> +install -Dpm 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service

OK.

New spec: http://michael.cronenworth.com/RPMS/miniupnpd.spec
New SRPM: http://michael.cronenworth.com/RPMS/miniupnpd-2.1-2.fc28.src.rpm

Comment 4 Eamon Walsh 2018-06-05 10:28:03 UTC
(In reply to comment #3)

> Why? The man page is better.

I was suggesting to add a second Documentation line, the way /usr/lib/systemd/system/systemd-machined.service does.

For STRIP, I only suggested /bin/true to make clear that STRIP is a path to an executable and not a boolean option.

I would approve at this point, if was in the packager group. Sorry about that.

For completeness, I'm going to paste my own fedora-review output in another comment.

Comment 5 Eamon Walsh 2018-06-05 10:31:06 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD 3-clause "New" or "Revised" License", "Unknown or
     generated". 137 files have unknown license. Detailed output of
     licensecheck in /home/user/1585365-miniupnpd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     miniupnpd-debuginfo , miniupnpd-debugsource
[x]: Package functions as described.
     NOTE: verified that the daemon starts with systemctl after setting a
     listening_ip and ext_ifname in the configuration file

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
     NOTE: the upstream home page does have a French version. The description
     and summary text do not appear to come from that page however.

[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
     NOTE: no test target in upstream Makefile

[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: miniupnpd-2.1-1.fc29.x86_64.rpm
          miniupnpd-debuginfo-2.1-1.fc29.x86_64.rpm
          miniupnpd-debugsource-2.1-1.fc29.x86_64.rpm
          miniupnpd-2.1-1.fc29.src.rpm
miniupnpd.x86_64: W: spelling-error %description -l en_US UPnP -> Upon
miniupnpd.x86_64: W: install-file-in-docs /usr/share/doc/miniupnpd/INSTALL
NOTE: there are configuration instructions in INSTALL

miniupnpd.src: W: spelling-error %description -l en_US UPnP -> Upon
miniupnpd.src: W: strange-permission miniupnpd.service 640
NOTE: adjust "upstream" permission on the service file

4 packages and 0 specfiles checked; 0 errors, 4 warnings.



Rpmlint (debuginfo)
-------------------
Checking: miniupnpd-debuginfo-2.1-1.fc29.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Rpmlint (installed packages)
----------------------------
miniupnpd.x86_64: W: spelling-error %description -l en_US UPnP -> Upon
miniupnpd.x86_64: W: install-file-in-docs /usr/share/doc/miniupnpd/INSTALL
1 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
miniupnpd (rpmlib, GLIBC filtered):
    /bin/sh
    config(miniupnpd)
    libc.so.6()(64bit)
    libip4tc.so.0()(64bit)
    libip6tc.so.0()(64bit)
    libuuid.so.1()(64bit)
    libuuid.so.1(UUID_1.0)(64bit)
    rtld(GNU_HASH)

miniupnpd-debugsource (rpmlib, GLIBC filtered):

miniupnpd-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
miniupnpd:
    config(miniupnpd)
    miniupnpd
    miniupnpd(x86-64)

miniupnpd-debugsource:
    miniupnpd-debugsource
    miniupnpd-debugsource(x86-64)

miniupnpd-debuginfo:
    debuginfo(build-id)
    miniupnpd-debuginfo
    miniupnpd-debuginfo(x86-64)



Source checksums
----------------
http://miniupnp.free.fr/files/miniupnpd-2.1.tar.gz :
  CHECKSUM(SHA256) this package     : 950894779661197fe093855fda29a728f434b5756eb4fa6cb5f7b9bff7ffe0c1
  CHECKSUM(SHA256) upstream package : 950894779661197fe093855fda29a728f434b5756eb4fa6cb5f7b9bff7ffe0c1


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1585365
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 6 Robert-André Mauchin 🐧 2018-06-05 15:03:46 UTC
Package approved.

Comment 7 Michael Cronenworth 2018-06-05 15:07:50 UTC
Thanks, Eamon & Robert-André.

Comment 8 Gwyn Ciesla 2018-06-05 15:20:17 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/miniupnpd

Comment 9 Fedora Update System 2018-06-06 16:24:59 UTC
miniupnpd-2.1-1.fc28 has been submitted as an update to Fedora 28. https://bodhi.fedoraproject.org/updates/FEDORA-2018-0001b48b68

Comment 10 Fedora Update System 2018-06-07 13:18:05 UTC
miniupnpd-2.1-1.fc28 has been pushed to the Fedora 28 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2018-0001b48b68

Comment 11 Fedora Update System 2018-06-15 15:49:02 UTC
miniupnpd-2.1-1.fc28 has been pushed to the Fedora 28 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.